#########################################################################
# Copyright (c) 2011 KSI Labs, LLC. All rights reserved.		#
# Written by Sergey Kubushyn <ksi@koi8.net>, <ksi@ksilabs.com>.		#
#########################################################################
# File: centipede_pci.sdc						#
#									#
# TimeQuest constraints file for the entire design. Fitter should be	#
# set to multicorner (both Slow and Fast corner constraints used for	#
# placement/routing so all timing requirements will be met.)		#
#########################################################################


#########################################################################
#			LICENSE and Terms of Use.			#
#									#
# First of all, this is NOT GPL or Free Software. It is open so you	#
# have the VHDL source code. There is also the source code for the	#
# Windows Engine for Mach3 CNC software available from KSI Labs, LLC	#
# website, http://www.ksilabs.com.					#
#									#
# You are free to use this particular VHDL code, make modifications to	#
# customize it for your own needs, fix inevitable bugs, port it to 	#
# other CNC software and do anything else as long as your derivative	#
# work that is based on this code or uses parts or pieces thereof is	#
# made to be used with any KSI Labs, LLC products.			#
#									#
# We do NOT grant you a permission to use any parts of this code in	#
# any products that are designed for products not manufactured or	#
# distributed by KSI Labs, LLC. We might give such a permission on	#
# case-by-case basis but it is not legal to use this code or bits and	#
# pieces thereof with products not coming from KSI Labs, LLC without	#
# our explicit written permission.					#
#									#
# The original copyright notices must be included in all derivative	#
# works. You do NOT have to ask our permission to make any changes to	#
# this code and you are not under obligation to give us any of your	#
# work back as long as you are using it for your own needs.		#
#									#
# However we do NOT give our permission to distribute your derivative	#
# work unless all original copyrights are retained, all the conditions	#
# of this license are met (use only with KSI Labs, LLC products) and	#
# full source code for such derivative work is available for free to	#
# everybody without any further conditions including but not limited	#
# to signing any kinds of NDA. We explicitely deny any permission to	#
# distribute any derivative work based on this code with closed source	#
# binary-only fragments or include bits or pieces of this code in such	#
# products. That essentially means that it is NOT legal to use it with	#
# ANY proprietary HDL megafunctions, megacores, etc. if the resulting	#
# product is distributed. It IS legal to use whatever you want if the	#
# resulting product is made for use with a KSI Labs, LLC product AND	#
# that resulting product is not distributed. Exclusions can be granted	#
# by KSI Labs, LLC on case-by-case basis.				#
#########################################################################


create_clock -period 30.000 -name {l_clk} {l_clk}
create_clock -period 30.000 -name pci_clk

##set_multicycle_path -from [get_ports {l_ad[*]}] -to [get_registers {extbus_gpio:u5|data_reg[*]}] -hold -start 1
##set_multicycle_path -from [get_ports {l_ad[*]}] -to [get_registers {extbus_gpio:u5|dir_reg[*]}] -hold -start 1
##set_multicycle_path -from [get_keepers {extbus_gpio:u5|data_reg[*]}] -to [get_ports {ext[*]}] -hold -start 1
##set_multicycle_path -from [get_ports {ext[*]}] -to [get_registers {extbus_gpio:u5|data_reg[*]}] -hold -start 1

set_multicycle_path -from [get_ports {l_ad[*]}] -to [get_registers {d_out_reg[*]}] -hold -start 1
set_multicycle_path -from [get_ports {l_ad[*]}] -to [get_registers {irqmask_reg[*]}] -hold -start 1
set_multicycle_path -from [get_ports {l_ad[*]}] -to [get_registers {irqstat_reg[*]}] -hold -start 1
set_multicycle_path -from [get_ports {l_ad[*]}] -to [get_registers {mach3_main:u4|mach3_cfg_reg[*]}] -hold -start 1
set_multicycle_path -from [get_ports {l_ad[*]}] -to [get_registers {mach3_main:u4|mach3_cfg2_reg[*]}] -hold -start 1
set_multicycle_path -from [get_ports {l_ad[*]}] -to [get_registers {mach3_main:u4|mach3_cfg3_reg[*]}] -hold -start 1
set_multicycle_path -from [get_ports {l_ad[*]}] -to [get_registers {mach3_main:u4|mach3_index:z2|idx[*][*]}] -hold -start 1
set_multicycle_path -from [get_ports {l_ad[*]}] -to [get_registers {mach3_main:u4|mach3_spindle:z6|s_stsp_ctl[*]}] -hold -start 1

set_multicycle_path -from [get_keepers {d_out_reg[*]}] -to [get_ports {d_out[*]}] -hold -start 1

set_multicycle_path -from [get_ports {d_in[?]}] -to [get_registers {d_in_reg[?]}] -hold -start 1
set_multicycle_path -from [get_ports {d_in[1?]}] -to [get_registers {d_in_reg[1?]}] -hold -start 1
set_multicycle_path -from [get_ports {d_in[20]}] -to [get_registers {d_in_reg[20]}] -hold -start 1
set_multicycle_path -from [get_ports {d_in[21]}] -to [get_registers {d_in_reg[21]}] -hold -start 1
set_multicycle_path -from [get_ports {d_in[22]}] -to [get_registers {d_in_reg[22]}] -hold -start 1
set_multicycle_path -from [get_ports {d_in[23]}] -to [get_registers {d_in_reg[23]}] -hold -start 1
set_multicycle_path -from [get_keepers {d_in_reg[?]}] -to [get_registers *] -hold -start 1
set_multicycle_path -from [get_keepers {d_in_reg[1?]}] -to [get_registers *] -hold -start 1
set_multicycle_path -from [get_keepers {d_in_reg[20]}] -to [get_registers *] -hold -start 1
set_multicycle_path -from [get_keepers {d_in_reg[21]}] -to [get_registers *] -hold -start 1
set_multicycle_path -from [get_keepers {d_in_reg[22]}] -to [get_registers *] -hold -start 1
set_multicycle_path -from [get_keepers {d_in_reg[23]}] -to [get_registers *] -hold -start 1

set_multicycle_path -from [get_keepers {tlv5617a_dac:u2|thr[15]}] -to [get_ports {losi1}] -hold -start 1
set_multicycle_path -from [get_keepers {tlv5617a_dac:u2|fsm_cur.DAC_RDY}] -to [get_ports {lss11}] -hold -start 1
set_multicycle_path -from [get_keepers {tlv5617a_dac:u2|fsm_cur.DAC_LATCH}] -to [get_ports {lpck1}] -hold -start 1

set_multicycle_path -from [get_keepers {tlv1544_adc:u3|thr[9]}] -to [get_ports {losi2}] -hold -start 1
set_multicycle_path -from [get_keepers {tlv1544_adc:u3|fsm_cur.ADC_RDY}] -to [get_ports {lss21}] -hold -start 1
set_multicycle_path -from [get_keepers {tlv1544_adc:u3|fsm_cur.ADC_CONVERSION}] -to [get_ports {lss21}] -hold -start 1
set_multicycle_path -from [get_keepers {tlv1544_adc:u3|fsm_cur.ADC_LATCH}] -to [get_ports {lpck2}] -hold -start 1

##set_output_delay 0.0 -clock pci_clk [get_ports {ext[*]}]

set_output_delay 0.0 -clock pci_clk [get_ports {d_out[*]}]
set_output_delay 0.0 -clock pci_clk [get_ports {losi*}]
set_output_delay 0.0 -clock pci_clk [get_ports {lpck*}]
set_output_delay 0.0 -clock pci_clk [get_ports {lss*}]
set_output_delay 0.0 -clock pci_clk [get_ports {l_inta}]
set_output_delay 0.0 -clock pci_clk [get_ports {l_stop}]
set_output_delay 0.0 -clock pci_clk [get_ports {l_devsel}]
set_output_delay 0.0 -clock pci_clk [get_ports {l_trdy}]
set_output_delay 0.0 -clock pci_clk [get_ports {l_par}]
set_output_delay 0.0 -clock pci_clk [get_ports {l_perr}]
set_output_delay 0.0 -clock pci_clk [get_ports {l_serr}]
set_output_delay 0.0 -clock pci_clk [get_ports {l_ad[*]}]

##set_input_delay 0.0 -clock pci_clk [get_ports {ext[*]}]

set_input_delay 0.0 -clock pci_clk [get_ports {d_in[*]}]
set_input_delay 0.0 -clock pci_clk [get_ports {liso*}]
set_input_delay 0.0 -clock pci_clk [get_ports {l_irdy}]
set_input_delay 0.0 -clock pci_clk [get_ports {l_rst}]
set_input_delay 0.0 -clock pci_clk [get_ports {l_frame}]
set_input_delay 0.0 -clock pci_clk [get_ports {l_cbe[*]}]
set_input_delay 0.0 -clock pci_clk [get_ports {l_idsel}]
set_input_delay 0.0 -clock pci_clk [get_ports {l_ad[*]}]

set_max_delay 14 -from [get_keepers {pci32ttiny:u1|devsel}] -to [get_ports {l_devsel}]
set_max_delay 14 -from [get_keepers {pci32ttiny:u1|trdy}] -to [get_ports {l_trdy}]
set_max_delay 14 -from [get_keepers {pci32ttiny:u1|tgt_oe}] -to [get_ports {l_devsel}]
set_max_delay 14 -from [get_keepers {pci32ttiny:u1|par_out}] -to [get_ports {l_par}]
set_max_delay 16 -from [get_keepers {lb_dout[*]}] -to [get_ports {l_ad[*]}]
set_max_delay 28 -from [get_keepers {pci32ttiny:u1|pci_data_oe}] -to [get_ports {l_ad[*]}]
set_max_delay 28 -from [get_keepers {pci32ttiny:u1|tgt_oe}] -to [get_ports {l_trdy}]
set_max_delay 28 -from [get_keepers {pci32ttiny:u1|pci_par_oe}] -to [get_ports {l_par}]

set_min_delay 0 -from [get_keepers {pci32ttiny:u1|devsel}] -to [get_ports {l_devsel}]
set_min_delay 0 -from [get_keepers {pci32ttiny:u1|trdy}] -to [get_ports {l_trdy}]
set_min_delay 0 -from [get_keepers {pci32ttiny:u1|tgt_oe}] -to [get_ports {l_devsel}]
set_min_delay 0 -from [get_keepers {pci32ttiny:u1|par_out}] -to [get_ports {l_par}]
set_min_delay 0 -from [get_keepers {pci32ttiny:u1|par_out}] -to [get_ports {l_par}]
set_min_delay 0 -from [get_keepers {lb_dout[*]}] -to [get_ports {l_ad[*]}]
set_min_delay 0 -from [get_keepers {pci32ttiny:u1|pci_data_oe}] -to [get_ports {l_ad[*]}]
set_min_delay 0 -from [get_keepers {pci32ttiny:u1|tgt_oe}] -to [get_ports {l_trdy}]
set_min_delay 0 -from [get_keepers {pci32ttiny:u1|pci_par_oe}] -to [get_ports {l_par}]
